/*******************************************************************************
 * FoxCustomizationNode_Base generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_Base extends Object within FoxArmoryUI
    abstract
    native(UI)
    config(UI);

enum EFiltersState
{
    EFS_None,
    EFS_UnlockedOnly,
    EFS_OwnedOnly,
    EFS_Both,
    EFS_MAX
};

struct native ScrollerListEntry extends BaseStoreEntry
{
    var init bool bEquipped;
    var int VersionNumber;
    var int InsertIndex;
    var init string sButtonLabel;
    var init string sAdditionalTooltip;
    var init string sAdditionalBtnFunc;
    var init string extRolloverInterfaceFunc;
    var init string extRolloverInterfaceArg;
    var init string extRolloutInterfaceFunc;
    var init string extRolloutInterfaceArg;
    var string sCurrencyColor2;
    var string sCurrencyColor;
    var init bool bBlankEntry;
    var init string sHeader;
};

var const config array<config ArmoryNodeWidgetConfig> NodeWidgetConfigs;
var const config string NodeWidgetClickFunc;
var transient array<ScrollerListEntry> ScrollerEntries;
var transient int AssociatedUnlockID;
var transient int EquippedUnlockID;
var int CurrentScrollerIndex;
var int CurrentScrollerUnlock;
var int ItemPurchaseScrollerIndex;
var bool bIsFilterUIOpen;
var bool bEquipConsume;
var bool bSetScrollerFocus;
var bool bComponentSlots;
var GFxObject ArmoryDialogBox;
var int PrevScrollerIndex;
var int CurrentFilterState;
var const config string ZCoinColor;
var const config string GPColor;
var string ItemRendererSymbol;
var transient array<StoreOfferMetaData> FeaturedItems;

function Initialize(optional bool bSelectEquipped)
{
    local array<string> FeaturedOffers;
    local FoxItemCacheStore StoreCache;

    bSelectEquipped = true;
    // End:0x7C
    if(class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache))
    {
        FeaturedOffers.AddItem("Featured");
        StoreCache.GetCachedOffers(FeaturedItems, FeaturedOffers, "", true);
    }
    AssociatedUnlockID = 0;
    Outer.Outer.ArmoryItemGrid.as_updateItemRenderer(ItemRendererSymbol);
    // End:0x146
    if(ScrollerEntries.Length == 0)
    {
        // End:0x117
        if(Outer.bShowUsable)
        {
            CurrentFilterState += 1;
        }
        // End:0x146
        if(Outer.bShowOwned)
        {
            CurrentFilterState += 2;
        }
    }
    //return;    
}

function Cleanup()
{
    local int I;

    Outer.bIgnoreZoom = false;
    Outer.Outer.Outer.PCOwner.ClearTimer('DelayedSetupScrollerBar');
    // End:0x135
    if(Outer.Outer.Outer.RelatedItem != none)
    {
        Outer.Outer.Outer.RelatedItem.CloseRelatedItemWidget();
    }
    Outer.CaptureActor.ClearCaptureList();
    Outer.HideWorkingDialog();
    // End:0x1A1
    if(ArmoryDialogBox != none)
    {
        as_hideDialog();
    }
    I = 0;
    J0x1AC:
    // End:0x1E6 [Loop If]
    if(I < ScrollerEntries.Length)
    {
        PrestreamIndex(I, false);
        ++ I;
        // [Loop Continue]
        goto J0x1AC;
    }
    //return;    
}

// Export UFoxCustomizationNode_Base::execSetEquipped(FFrame&, void* const)
native function SetEquipped(out ScrollerListEntry ScrollerEntry, optional bool bSelectEquipped);

// Export UFoxCustomizationNode_Base::execOrganizeStoreEntries(FFrame&, void* const)
native function OrganizeStoreEntries();

event int GetNumOfItemUsed(int ItemId)
{
    return 0;
    //return ReturnValue;    
}

event as_toggleFiltersUI()
{
    AddFilterButtons();
    //return;    
}

event PurchaseExtensionOrPinItemClick()
{
    local ScrollerListEntry SelectedEntry;

    SelectedEntry = ScrollerEntries[CurrentScrollerIndex];
    // End:0x52
    if(SelectedEntry.PurchaseState == 3)
    {
        TryPurchaseCurrentUnlockID();
    }
    // End:0x89
    else
    {
        // End:0x89
        if(!SelectedEntry.bIsPurchased)
        {
            ei_AddToWishList(string(CurrentScrollerIndex));
        }
    }
    //return;    
}

function SetSelectedUnlock(int UnlockID, bool bScrollerFocus)
{
    local DialogBoxProperties DBProperties;
    local int MinimartScrollerIndex;

    Outer.SelectedScrollerIndex = ScrollerEntries.Find('UnlockID', UnlockID);
    // End:0x2B1
    if(Outer.SelectedScrollerIndex == -1)
    {
        // End:0xA0
        if(!bScrollerFocus)
        {
            Outer.SelectedScrollerIndex = CurrentScrollerIndex;
        }
        // End:0x2B1
        else
        {
            Outer.SelectedScrollerIndex = ScrollerEntries.Find('bEquipped', true);
            // End:0x2B1
            if(Outer.SelectedScrollerIndex == -1)
            {
                Outer.SelectedScrollerIndex = 0;
                // End:0x2B1
                if(UnlockID != 0)
                {
                    DBProperties.DialogType = 1;
                    DBProperties.TitleText = Outer.Outer.LocalizeMenuString("ItemHiddenTitle", "ARMORY");
                    DBProperties.BodyText = Outer.Outer.LocalizeMenuString("ItemHiddenDetail", "ARMORY");
                    DBProperties.bShowTimer = false;
                    DBProperties.bCloseOnButtonPress = true;
                    Outer.Outer.Outer.ShowDialogBox(DBProperties);
                }
            }
        }
    }
    // End:0x361
    if((Outer.SelectedScrollerIndex >= 0) && Outer.SelectedScrollerIndex < ScrollerEntries.Length)
    {
        Outer.SelectedScrollerUnlock = ScrollerEntries[Outer.SelectedScrollerIndex].UnlockID;
    }
    // End:0x381
    else
    {
        Outer.SelectedScrollerUnlock = 0;
    }
    // End:0x4A9
    if(((Outer.SelectedScrollerIndex >= 0) && Outer.SelectedScrollerIndex < ScrollerEntries.Length) && bScrollerFocus)
    {
        MinimartScrollerIndex = ScrollerEntries.Find('UnlockID', Outer.SelectedUnlockID);
        Outer.Outer.ArmoryItemGrid.as_SetSelectedItem(((MinimartScrollerIndex != -1) ? MinimartScrollerIndex : Outer.SelectedScrollerIndex));
    }
    // End:0x53A
    else
    {
        CurrentScrollerIndex = ScrollerEntries.Find('UnlockID', CurrentScrollerUnlock);
        Outer.Outer.ArmoryItemGrid.as_SetSelectedItem(((CurrentScrollerIndex != -1) ? CurrentScrollerIndex : 0));
    }
    // End:0x586
    if(Outer.SelectedUnlockID != -1)
    {
        Outer.SelectedUnlockID = -1;
    }
    //return;    
}

function ei_RolloverItem(string NewIndex)
{
    ei_changeScrollerIndex(int(NewIndex));
    //return;    
}

function ei_RolloutItem(string Index)
{
    ei_changeScrollerIndex(Outer.SelectedScrollerIndex);
    //return;    
}

function ei_changeScrollerIndex(int NewIndex)
{
    local string FilterString, ColorString;

    // End:0x110
    if(Outer.Outer.Outer.PCOwner.MyFoxInput.bUsingGamepad)
    {
        FilterString = Outer.Outer.LocalizeMenuString("Filters");
        ColorString = Outer.Outer.LocalizeMenuString("Color_X", "Social");
    }
    // End:0x1A8
    else
    {
        FilterString = Outer.Outer.LocalizeMenuString("Filters_PC");
        ColorString = Outer.Outer.LocalizeMenuString("Color", "Social");
    }
    CurrentScrollerIndex = NewIndex;
    CurrentScrollerUnlock = ScrollerEntries[NewIndex].UnlockID;
    UpdateNodeDetails();
    // End:0x356
    if(((ScrollerEntries[NewIndex].PurchaseState == 3) && class'WorldInfo'.static.IsConsoleBuild()) && Outer.CustomItemType != 20)
    {
        Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(Outer.Outer.LocalizeMenuString("ExtendRental") @ FilterString), true);
    }
    // End:0x747
    else
    {
        // End:0x5C2
        if((class'WorldInfo'.static.IsConsoleBuild() && ScrollerEntries[NewIndex].PurchaseState != 3) && ScrollerEntries[NewIndex].PurchaseState != 4)
        {
            // End:0x4E3
            if(Outer.CustomItemType != 20)
            {
                Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(Outer.Outer.LocalizeMenuString("PinItem") @ FilterString), true);
            }
            // End:0x5BF
            else
            {
                Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(Outer.Outer.LocalizeMenuString("PinItem") @ ColorString), false);
            }
        }
        // End:0x747
        else
        {
            // End:0x686
            if(Outer.CustomItemType != 20)
            {
                Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(FilterString), true);
            }
            // End:0x747
            else
            {
                // End:0x747
                if(Outer.CustomItemType == 20)
                {
                    Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(ColorString), false);
                }
            }
        }
    }
    PreStreamIndices(Max(NewIndex - 2, 0), Min(NewIndex + 2, ScrollerEntries.Length - 1), ScrollerEntries.Length);
    //return;    
}

private final function PreStreamIndices(int iStart, int iEnd, int iMax)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x70 [Loop If]
    if(I < iMax)
    {
        PrestreamIndex(I, (I >= iStart) && I <= iEnd);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function PrestreamIndex(int iIndex, bool bStreamIn)
{
    //return;    
}

function PrestreamMesh(SkeletalMesh Mesh, bool bEnable)
{
    local int I;

    // End:0xA4
    if(Mesh != none)
    {
        I = 0;
        J0x1A:
        // End:0xA4 [Loop If]
        if(I < Mesh.Materials.Length)
        {
            Mesh.Materials[I].SetForceMipLevelsToBeResident(true, bEnable, 10.0);
            ++ I;
            // [Loop Continue]
            goto J0x1A;
        }
    }
    //return;    
}

function AddFilterButtons()
{
    CurrentFilterState = (CurrentFilterState + 1) % 4;
    switch(CurrentFilterState)
    {
        // End:0x4A
        case 0:
            FilterUsableToggle(false);
            FilterOwnedToggle(false);
            // End:0xA9
            break;
        // End:0x68
        case 2:
            FilterUsableToggle(false);
            FilterOwnedToggle(true);
            // End:0xA9
            break;
        // End:0x85
        case 1:
            FilterUsableToggle(true);
            FilterOwnedToggle(false);
            // End:0xA9
            break;
        // End:0xA3
        case 3:
            FilterUsableToggle(true);
            FilterOwnedToggle(true);
            // End:0xA9
            break;
        // End:0xFFFF
        default:
            // End:0xA9
            break;
    }
    RebuildScroller();
    UpdateEmbeddedFilterDisplay();
    //return;    
}

function ei_filterUsableToggle(string Selected)
{
    FilterUsableToggle(int(Selected) == 1);
    RebuildScroller();
    UpdateEmbeddedFilterDisplay();
    //return;    
}

function ei_filterOwnedToggle(string Selected)
{
    FilterOwnedToggle(int(Selected) == 1);
    RebuildScroller();
    UpdateEmbeddedFilterDisplay();
    //return;    
}

function string as_makeDialogBox(GFxObject WidgetContainer, string S)
{
    return Outer.Outer.Outer.ActionScriptString("_root.makeDialogBox");
    //return ReturnValue;    
}

function as_setDialogHeader(string Label)
{
    ArmoryDialogBox.ActionScriptVoid("checkBoxData");
    //return;    
}

function as_checkBoxData(float Index, GFxObject Data)
{
    ArmoryDialogBox.ActionScriptVoid("checkBoxData");
    //return;    
}

function as_basicButtonData(float Index, GFxObject Data)
{
    ArmoryDialogBox.ActionScriptVoid("basicButtonData");
    //return;    
}

function as_hideDialog()
{
    ArmoryDialogBox.ActionScriptVoid("removeDialogBox");
    ArmoryDialogBox = none;
    //return;    
}

function ei_filterQuickPurchase(bool bNewValue)
{
    Outer.bQuickPurchase = bNewValue;
    //return;    
}

function FilterUsableToggle(bool bNewValue)
{
    Outer.bShowUsable = bNewValue;
    //return;    
}

function FilterOwnedToggle(bool bNewValue)
{
    Outer.bShowOwned = bNewValue;
    //return;    
}

function RebuildScroller(optional bool bSelectEquipped)
{
    bSelectEquipped = false;
    Initialize(bSelectEquipped);
    UpdateSaleTimers();
    //return;    
}

function UpdateEmbeddedFilterDisplay()
{
    local GFxObject Data;
    local string FilterString;

    // End:0xC1
    if(Outer.Outer.Outer.PCOwner.MyFoxInput.bUsingGamepad)
    {
        FilterString = Outer.Outer.LocalizeMenuString("Filters");
    }
    // End:0x10C
    else
    {
        FilterString = Outer.Outer.LocalizeMenuString("Filters_PC");
    }
    // End:0x6D7
    if(Outer.Outer.ArmoryItemGrid != none)
    {
        Outer.Outer.ArmoryItemGrid.as_filtersPromptData(Outer.Outer.Outer.ParseStringForCommands(FilterString), true);
        Data = Outer.Outer.Outer.CreateObject("Object");
        Data.SetString("sIcon", "img://Menu.t_filterLockIcon");
        // End:0x39C
        if(!Outer.Outer.Outer.GetWorldInfo().IsConsoleBuild())
        {
            Data.SetString("sClickFunc", "ei_filterUsableToggle");
            Data.SetString("sTooltip", Outer.Outer.LocalizeMenuString("HideLockedToolTip"));
        }
        Data.SetBool("bChecked", Outer.bShowUsable);
        Outer.Outer.Outer.PCOwner.DynamicUI.Menu.ArmoryItemGrid.as_checkBoxData(0, Data);
        Data.SetString("sIcon", "img://Menu.t_filterOwnedIcon");
        // End:0x5E8
        if(!Outer.Outer.Outer.GetWorldInfo().IsConsoleBuild())
        {
            Data.SetString("sClickFunc", "ei_filterOwnedToggle");
            Data.SetString("sTooltip", Outer.Outer.LocalizeMenuString("OnlyOwnedToolTip"));
        }
        Data.SetBool("bChecked", Outer.bShowOwned);
        Outer.Outer.Outer.PCOwner.DynamicUI.Menu.ArmoryItemGrid.as_checkBoxData(1, Data);
    }
    //return;    
}

function ei_buyItem(string Param)
{
    TryPurchaseCurrentUnlockID();
    //return;    
}

function ei_buyRelatedItem(string UnlockIDStr)
{
    TryPurchaseCurrentUnlockID(int(UnlockIDStr));
    //return;    
}

function ei_activateItem(string Param)
{
    TryActivateCurrentUnlockID();
    //return;    
}

function int GetCurrentUnlockID()
{
    return ScrollerEntries[CurrentScrollerIndex].UnlockID;
    //return ReturnValue;    
}

function FoxTypes.EUnlockState GetCurrentUnlockState()
{
    return ScrollerEntries[CurrentScrollerIndex].UnlockState;
    //return ReturnValue;    
}

function FoxTypes.EPurchaseState GetCurrentPurchaseState()
{
    return ScrollerEntries[CurrentScrollerIndex].PurchaseState;
    //return ReturnValue;    
}

function TryPurchaseCurrentUnlockID(optional int UnlockID, optional FoxTypes.EUnlockState UnlockState, optional bool bIgnoreQuickPurchase)
{
    local FoxTypes.EPurchaseState PurchaseState;

    UnlockState = 2;    
    // End:0x53
    if(UnlockID == 0)
    {
        UnlockID = GetCurrentUnlockID();
        UnlockState = GetCurrentUnlockState();
        PurchaseState = GetCurrentPurchaseState();
    }
    ItemPurchaseScrollerIndex = CurrentScrollerIndex;
    Outer.Outer.Outer.PurchaseItemByUnlockID(UnlockID, 1, StorePurchaseComplete, true, PurchaseState <= 2, false, "", AssociatedUnlockID);
    //return;    
}

function TryActivateCurrentUnlockID()
{
    local FoxActivateItemUI ActivateItemUI;
    local FoxItemCacheStore StoreCache;
    local FoxItemCacheInventory InventoryCache;
    local StoreMetaData StoreItem;
    local array<InventoryMetaData> InventoryItems;

    // End:0x337
    if(((class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) && StoreCache.GetCachedItemByUnlockID(StoreItem, Outer.SelectedScrollerUnlock)) && StoreItem.ItemId == Outer.SelectedScrollerUnlock) && StoreItem.ActivationType != 5)
    {
        // End:0x334
        if((class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache) && InventoryCache.GetCachedItems(InventoryItems, Outer.SelectedScrollerUnlock, 1)) && InventoryItems.Length > 0)
        {
            ActivateItemUI = new (Outer.Outer.Outer.PCOwner.DynamicUI) class'FoxActivateItemUI';
            ActivateItemUI.StoreItems.AddItem(StoreItem);
            ActivateItemUI.InventoryItems.AddItem(InventoryItems[0]);
            ActivateItemUI.bEquip = true;
            ActivateItemUI.__PostActivateItem__Delegate = StorePurchaseComplete;
            ActivateItemUI.__OnWorkingDialogShow__Delegate = Outer.ShowWorkingDialog;
            ActivateItemUI.__OnWorkingDialogHide__Delegate = Outer.HideWorkingDialog;
            ActivateItemUI.ActivateItem();
        }
    }
    // End:0x341
    else
    {
        TryConsumeCurrentUnlockID();
    }
    //return;    
}

function TryConsumeCurrentUnlockID()
{
    local FoxConsumeItemUI ConsumeItemUI;

    // End:0x1DB
    if(ScrollerEntries[CurrentScrollerIndex].ActivationType == 5)
    {
        ConsumeItemUI = new (Outer.Outer.Outer.PCOwner.DynamicUI) class'FoxConsumeItemUI';
        ConsumeItemUI.UnlockID = Outer.SelectedScrollerUnlock;
        ConsumeItemUI.ConsumeAmount = 1;
        ConsumeItemUI.__PostConsumeItem__Delegate = StoreConsumeComplete;
        ConsumeItemUI.__OnWorkingDialogShow__Delegate = Outer.ShowWorkingDialog;
        ConsumeItemUI.__OnWorkingDialogHide__Delegate = Outer.HideWorkingDialog;
        ConsumeItemUI.StartTask();
    }
    //return;    
}

function StorePurchaseComplete(bool bSuccess, bool bEquip)
{
    local FoxItemCacheInventory InventoryCache;
    local FoxServerConnection ServerConn;
    local array<InventoryMetaData> UpdatedItems;
    local int CachedPurchasedUnlockID;

    ServerConn = FoxServerConnection(Outer.Outer.Outer.PCOwner.WorldInfo.ServerConn);
    // End:0x1F2
    if(((bSuccess && ServerConn != none) && class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache)) && InventoryCache.HasUpdatedItems(UpdatedItems,, true))
    {
        InventoryCache.MergeUpdatedItems();
        ServerConn.ApplyInventoryFromCache();
        // End:0x199
        if((ScrollerEntries[ItemPurchaseScrollerIndex].ActivationType != 5) || !bEquipConsume)
        {
            NodeEquipButtonClicked(string(ItemPurchaseScrollerIndex));
        }
        // End:0x1A3
        else
        {
            TryConsumeCurrentUnlockID();
        }
        CachedPurchasedUnlockID = ScrollerEntries[ItemPurchaseScrollerIndex].UnlockID;
        RebuildScroller();
        SetSelectedUnlock(CachedPurchasedUnlockID, true);
    }
    //return;    
}

function StoreConsumeComplete(bool bSuccess)
{
    // End:0x37
    if(bSuccess)
    {
        NodeEquipButtonClicked(string(Outer.SelectedScrollerIndex));
    }
    //return;    
}

function ReloadArmoryForItem(int UnlockID, FoxTypes.EPurchaseState PurchaseState)
{
    ScrollerEntries[Outer.SelectedScrollerIndex].PurchaseState = PurchaseState;
    switch(PurchaseState)
    {
        // End:0x5D
        case 4:
        // End:0xBF
        case 3:
            ScrollerEntries[Outer.SelectedScrollerIndex].sClickLabel = Outer.EquipClickLabel;
            // End:0x11F
            break;
        // End:0xFFFF
        default:
            ScrollerEntries[Outer.SelectedScrollerIndex].sClickLabel = Outer.PurchaseClickLabel;
            // End:0x11F
            break;
    }
    //return;    
}

function bool IsPurchased(int ItemId)
{
    return FoxServerConnection(Outer.Outer.Outer.PCOwner.WorldInfo.ServerConn).IsItemPurchased(ItemId, FoxPRI(Outer.Outer.Outer.PCOwner.PlayerReplicationInfo), AssociatedUnlockID);
    //return ReturnValue;    
}

// Export UFoxCustomizationNode_Base::execShouldShowItem(FFrame&, void* const)
native function bool ShouldShowItem(FoxTypes.EUnlockState UnlockState, optional FoxTypes.EPurchaseState PurchaseState)
{
    PurchaseState = 0;                
}

function UpdateNodeDetails()
{
    //return;    
}

// Export UFoxCustomizationNode_Base::execSetScrollerEntry(FFrame&, void* const)
native function bool SetScrollerEntry(out ScrollerListEntry ScrollerEntry, int UnlockID, optional bool bSelectEquipped, optional bool bAssumeOwned)
{
    bAssumeOwned = false;                        
}

// Export UFoxCustomizationNode_Base::execSetButtonLabel(FFrame&, void* const)
native function SetButtonLabel(out ScrollerListEntry ScrollerEntry, optional bool bSetEquipped)
{
    bSetEquipped = true;                
}

function SetupScrollerBar(bool bScrollerFocus)
{
    bSetScrollerFocus = bScrollerFocus;
    Outer.Outer.Outer.PCOwner.SetTimer(0.010, false, 'DelayedSetupScrollerBar', self);
    //return;    
}

function SetupRelatedItemWidget(optional int UnlockID, const optional array<int> UnlockIDs)
{
    // End:0xE7
    if(Outer.Outer.Outer.RelatedItem != none)
    {
        Outer.Outer.Outer.RelatedItem.ShowRelatedItemWidget("armoryDeal", 390, 185, "ei_buyRelatedItem", UnlockID, UnlockIDs);
    }
    //return;    
}

function DelayedSetupScrollerBar()
{
    local string sItemNumber;
    local int I;

    OrganizeStoreEntries();
    I = 0;
    J0x15:
    // End:0xB7 [Loop If]
    if(I < ScrollerEntries.Length)
    {
        class'FoxUI'.static.GetFormattedNumber(float(I + 1), sItemNumber, 0, 3);
        ScrollerEntries[I].sItemNumber = sItemNumber;
        SetCallbackData(I);
        ++ I;
        // [Loop Continue]
        goto J0x15;
    }
    Outer.Outer.ArmoryItemGrid.as_SetGridData(ScrollerEntries);
    Outer.Outer.Outer.Advance(0.0);
    SetSelectedUnlock(EquippedUnlockID, bSetScrollerFocus);
    Outer.bAdvanceComponentSlotsEnabled = true;
    UpdateSaleTimers();
    //return;    
}

// Export UFoxCustomizationNode_Base::execSortScrollerBar(FFrame&, void* const)
native function SortScrollerBar();

function ChangeEquippedScrollerEntry(int NewIndex)
{
    // End:0x7C
    if(NewIndex != Outer.SelectedScrollerIndex)
    {
        PrevScrollerIndex = Outer.SelectedScrollerIndex;
        Outer.SelectedScrollerIndex = NewIndex;
    }
    //return;    
}

function SetCallbackData(int Index)
{
    ScrollerEntries[Index].extRolloverInterfaceFunc = "ei_RolloverItem";
    ScrollerEntries[Index].extRolloverInterfaceArg = string(Index);
    ScrollerEntries[Index].extClickInterfaceFunc = "ei_ScrollerClicked";
    ScrollerEntries[Index].extClickInterfaceArg = string(Index);
    //return;    
}

function ei_AddToWishList(string AddIndex)
{
    NodeEquipButtonClicked(AddIndex);
    //return;    
}

function ei_ScrollerClicked(string SelectedIndex)
{
    local FoxTypes.EPurchaseState PurchaseState;
    local FoxTypes.EUnlockState UnlockState;
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    PurchaseState = ScrollerEntries[NextIndex].PurchaseState;
    UnlockState = ScrollerEntries[NextIndex].UnlockState;
    switch(PurchaseState)
    {
        // End:0x8D
        case 4:
        // End:0xA8
        case 3:
            NodeEquipButtonClicked(SelectedIndex);
            // End:0x166
            break;
        // End:0x11B
        case 1:
            // End:0x105
            if((ScrollerEntries[NextIndex].ActivationType == 5) && !bEquipConsume)
            {
                NodeEquipButtonClicked(SelectedIndex);
            }
            // End:0x118
            else
            {
                ei_activateItem(SelectedIndex);
            }
            // End:0x166
            break;
        // End:0x120
        case 0:
        // End:0x163
        case 2:
            switch(UnlockState)
            {
                // End:0x13D
                case 1:
                // End:0x142
                case 2:
                // End:0x15D
                case 3:
                    ei_buyItem(SelectedIndex);
                    // End:0x160
                    break;
                // End:0xFFFF
                default:
                    // End:0x166
                    break;
        }
        // End:0xFFFF
        default:
            //return;
    }    
}

function NodeEquipButtonClicked(string SelectedIndex)
{
    local ScrollerListEntry TempEntry;
    local string sIcon;
    local int OldInsertIndex;

    Outer.ei_equipButtonClicked(SelectedIndex);
    ChangeEquippedScrollerEntry(int(SelectedIndex));
    EquippedUnlockID = ScrollerEntries[Outer.SelectedScrollerIndex].UnlockID;
    TempEntry = ScrollerEntries[PrevScrollerIndex];
    sIcon = TempEntry.sIcon;
    SetScrollerEntry(TempEntry, TempEntry.UnlockID);
    TempEntry.sIcon = sIcon;
    OldInsertIndex = ScrollerEntries[PrevScrollerIndex].InsertIndex;
    ScrollerEntries[PrevScrollerIndex] = TempEntry;
    ScrollerEntries[PrevScrollerIndex].InsertIndex = OldInsertIndex;
    SetCallbackData(PrevScrollerIndex);
    Outer.Outer.ArmoryItemGrid.as_UpdateDataByIndex(PrevScrollerIndex, ScrollerEntries[PrevScrollerIndex]);
    TempEntry = ScrollerEntries[Outer.SelectedScrollerIndex];
    sIcon = TempEntry.sIcon;
    SetScrollerEntry(TempEntry, TempEntry.UnlockID);
    TempEntry.sIcon = sIcon;
    OldInsertIndex = ScrollerEntries[Outer.SelectedScrollerIndex].InsertIndex;
    ScrollerEntries[Outer.SelectedScrollerIndex] = TempEntry;
    ScrollerEntries[Outer.SelectedScrollerIndex].InsertIndex = OldInsertIndex;
    SetCallbackData(Outer.SelectedScrollerIndex);
    Outer.Outer.ArmoryItemGrid.as_UpdateDataByIndex(Outer.SelectedScrollerIndex, ScrollerEntries[Outer.SelectedScrollerIndex]);
    //return;    
}

event UpdateSaleTimers()
{
    local int OfferIndex, ItemIndex;
    local FoxItemCacheStore StoreCache;
    local array<StoreOfferMetaData> DiscountOffers;
    local string LocalizedDurationLabel;

    // End:0x7F
    if(!class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) || !StoreCache.GetCachedOffers(DiscountOffers, StoreCache.SaleOfferTags,, true))
    {
        return;
    }
    ItemIndex = 0;
    J0x8A:
    // End:0x3C1 [Loop If]
    if(ItemIndex < ScrollerEntries.Length)
    {
        // End:0x2DA
        if(ScrollerEntries[ItemIndex].PurchaseState < 4)
        {
            OfferIndex = 0;
            J0xDE:
            // End:0x2DA [Loop If]
            if(OfferIndex < DiscountOffers.Length)
            {
                // End:0x2CC
                if(DiscountOffers[OfferIndex].ItemGuid == ScrollerEntries[ItemIndex].ItemGuid)
                {
                    LocalizedDurationLabel = "";
                    Outer.Outer.Outer.PCOwner.DynamicUI.GetSaleDurationLabelFromTimeLeft(LocalizedDurationLabel, DiscountOffers[OfferIndex].EndDate);
                    // End:0x2C9
                    if(ScrollerEntries[ItemIndex].sSaleInfo != LocalizedDurationLabel)
                    {
                        ScrollerEntries[ItemIndex].sSaleInfo = LocalizedDurationLabel;
                        Outer.Outer.ArmoryItemGrid.as_updateItemTileByDataString(ItemIndex, "saleInfo", LocalizedDurationLabel, "sSaleInfo");
                    }
                    // [Explicit Break]
                    goto J0x2DA;
                }
                ++ OfferIndex;
                J0x2DA:
                // [Loop Continue]
                goto J0xDE;
            }
        }
        // End:0x3B3
        if((OfferIndex == DiscountOffers.Length) && ScrollerEntries[ItemIndex].sSaleInfo != "")
        {
            ScrollerEntries[ItemIndex].sSaleInfo = "";
            Outer.Outer.ArmoryItemGrid.as_updateItemTileByDataString(ItemIndex, "saleInfo", "", "sSaleInfo");
        }
        ++ ItemIndex;
        // [Loop Continue]
        goto J0x8A;
    }
    //return;    
}

function ei_FilterUIClosed()
{
    bIsFilterUIOpen = false;
    //return;    
}

defaultproperties
{
    ZCoinColor="0x6ccf67"
    GPColor="0x4dd3f6"
    ItemRendererSymbol="w_gridItem2.0"
}